Bug 108701 - package fails make test when built on certain dates
package fails make test when built on certain dates
Product: Red Hat Raw Hide
Classification: Retired
Component: at (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Marcela Mašláňová
: 108942 124365 (view as bug list)
Depends On:
  Show dependency treegraph
Reported: 2003-10-31 05:58 EST by Mario Lorenz
Modified: 2007-04-18 12:59 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-10-10 04:04:31 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Mario Lorenz 2003-10-31 05:58:17 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.2.1) Gecko/20030225

Description of problem:
Trying to rebuild at from the SRPM fails in the make test phase, when buildt on
certain dates (at the end of a month, like today, Oct 31 2003)

Analyzing it basically boils down to the question of wheter in 
"monday - 1 month" test.pl should assume this month or next month with
30 or 31 days to subtract.

So the test suite and at differ in their opinion on how this should be done. I
also cannot say which behaviour is right, I hope it is specified in some
standards somewhere...

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. date 103110102003 (I am CET in case this matters)
2. rpmbuild --rebuild 2.at-3.1.8-46.1.src.rpm
3. watch rpmbuild fail
4. run make TEST_VERBOSE=2 test in the at build directory

Actual Results:  rpmbuild fails
make test yields:
not ok
 'Monday - 1 month': 'Fri Oct  3 11:36:00 2003' =? 'Sat Oct  4 11:36:00 2003'
not ok
 'Monday + 1 month': 'Wed Dec  3 11:36:00 2003' =? 'Thu Dec  4 11:36:00 2003'

(and a few more of this kind)

Expected Results:  rpmbuild should have succeeded, make test should not have
found errors

Additional info:

I am not sure how to classify the severity of this bug. If its the test suite,
no problem. if its AT, then this could be potentially severe

I am not sure which distributions are affected. RH9 is not (-33)
RHEL3 is, and Fedora probably too
Comment 1 Mario Lorenz 2003-10-31 06:04:57 EST
What I forgot to add (but might be obvious from the bug description):
Building this two weeks earlier/later (or setting date apropriately)
causes the package to pass "make test" and be built. 
Comment 2 Milan Kerslager 2003-11-03 10:53:05 EST
I see this behavior to. This seems to me like locale problem. I tryed
various locale (C, EN_US, POSIX, en_US.UTF-8) and 4 or 5 tests failed.
I see "next week +- 1 month" tests failed too.

The solution for building the package is to use thic command:

rpmbuild --define "_without_check 1" -ba SPECS/at.spec
Comment 3 Bill Nottingham 2003-11-03 12:23:12 EST
*** Bug 108942 has been marked as a duplicate of this bug. ***
Comment 4 Mario Lorenz 2003-11-03 12:53:45 EST
I disagree. --define the check away is about the worst thing to do,
its cutting your lifeline...

Locale dependencies  result from the additional fact that "next week"
tests may yield different results per locale (eg. some start counting
the week on sundays, some on mondays. This is not the main problem here.

The main problem is simply that the order of operations is significant
when dealing with dates.

"Five days from now, and then a month later" is simply not the same
as "In a month, and then five days", when you are close to the end
of the month. (in one case, the "month later" may have 30 days, in
the other case 31 days)

Then again, it is usually accepted that when counting in months, you
count with 30 days.

Since both results are right in some way, it is a matter of making
test.pl agreeing on what at says or vice versa. Whats the correct way
is hopefully written in some unix standards...

Comment 5 Ryan Finnie 2004-05-04 01:36:56 EDT
I noticed this bug too, but I noticed that it only seems to occur if
you're building in a timezone that uses DST (like PST8PDT).  If you
run "make TZ=UTC test", the test harness succeeds.
Comment 6 Jason Vas Dias 2004-08-04 19:01:08 EDT
*** Bug 124365 has been marked as a duplicate of this bug. ***
Comment 7 Bill Nottingham 2006-08-07 21:40:40 EDT
'Red Hat Raw Hide' refers to the development tree for Red Hat Linux.
Red Hat Linux is no longer supported by Red Hat, Inc. If you are still
running Red Hat Linux, you are strongly advised to upgrade to a
current Fedora Core release or Red Hat Enterprise Linux or comparable.
Some information on which option may be right for you is available at

Red Hat apologizes that these issues were not resolved in a more
timely manner. However, we do want to make sure that important 
don't slip through the cracks. If these issues are still present
in a current release, such as Fedora Core 5, please move these
bugs to that product and version. Note that any remaining Red Hat
Raw Hide bugs will be closed as 'CANTFIX' on September 30, 2006.
Thanks again for your help.

Note You need to log in before you can comment on or make changes to this bug.